import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import { CloseDropDownOnClickDirective } from '@smallstack/common-components';
import { BehaviorSubject, combineLatest } from 'rxjs';
import { F as FilterBaseWidgetComponent } from './smallstack-form-widgets-filter-base-widget.component-1bb6ed87.mjs';
import '@angular/router';
import '@smallstack/utils';
import '@smallstack/widget-core';
import 'uuid';

class NumberFilterWidgetComponent extends FilterBaseWidgetComponent {
    constructor() {
        super();
        this.inputFrom$ = new BehaviorSubject(undefined);
        this.inputTo$ = new BehaviorSubject(undefined);
        this.subscription.add(combineLatest([this.value$, this.path$]).subscribe(([value, path]) => {
            if (value) {
                if (value[path]?.$gte)
                    this.inputFrom$.next(value[path].$gte);
                if (value[path]?.$lte)
                    this.inputTo$.next(value[path].$lte);
            }
            else {
                this.inputFrom$.next(undefined);
                this.inputTo$.next(undefined);
            }
        }));
        this.subscription.add(combineLatest([this.inputFrom$, this.inputTo$, this.path$]).subscribe(([from, to, path]) => {
            if (from || to) {
                const filter = {};
                if (from)
                    filter.$gte = from;
                if (to)
                    filter.$lte = to;
                void this.setFilter({ [path]: filter });
            }
            else
                void this.setFilter(undefined);
        }));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: NumberFilterWidgetComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: NumberFilterWidgetComponent, isStandalone: true, selector: "smallstack-number-filter-widget", usesInheritance: true, ngImport: i0, template: "<div class=\"join w-full\">\n  <input\n    type=\"number\"\n    placeholder=\"von\"\n    class=\"input input-bordered w-full join-item\"\n    [ngModel]=\"inputFrom$ | push\"\n    (ngModelChange)=\"inputFrom$.next($event)\"\n  />\n  <input\n    type=\"number\"\n    placeholder=\"bis\"\n    class=\"input input-bordered w-full join-item\"\n    [ngModel]=\"inputTo$ | push\"\n    (ngModelChange)=\"inputTo$.next($event)\"\n  />\n</div>\n", dependencies: [{ kind: "pipe", type: RxPush, name: "push" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: NumberFilterWidgetComponent, decorators: [{
            type: Component,
            args: [{ selector: "smallstack-number-filter-widget", standalone: true, imports: [RxPush, RxLet, FormsModule, CloseDropDownOnClickDirective], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"join w-full\">\n  <input\n    type=\"number\"\n    placeholder=\"von\"\n    class=\"input input-bordered w-full join-item\"\n    [ngModel]=\"inputFrom$ | push\"\n    (ngModelChange)=\"inputFrom$.next($event)\"\n  />\n  <input\n    type=\"number\"\n    placeholder=\"bis\"\n    class=\"input input-bordered w-full join-item\"\n    [ngModel]=\"inputTo$ | push\"\n    (ngModelChange)=\"inputTo$.next($event)\"\n  />\n</div>\n" }]
        }], ctorParameters: function () { return []; } });

export { NumberFilterWidgetComponent };
//# sourceMappingURL=smallstack-form-widgets-number-filter-widget.component-1e3536c4.mjs.map
