import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy } from '@angular/core';
import * as i1$1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i5 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i4 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i1 from '@smallstack/common-components';
import { UrlConformPipe, TranslatePipe } from '@smallstack/common-components';
import { DatestringEditorComponent } from '@smallstack/form-components';
import { I18nComponent } from '@smallstack/i18n-components';
import { StoreContainerComponent, StoreModelComponent } from '@smallstack/store-components';
import { IconComponent } from '@smallstack/theme-components';
import { WidgetRendererComponent } from '@smallstack/widget-core';
import { I as InputBaseWidgetComponent } from './smallstack-form-widgets-input-base-widget.component-e4949b87.mjs';
import '@smallstack/utils';
import 'rxjs';

class CustomFieldsInputWidgetComponent extends InputBaseWidgetComponent {
    constructor(customFieldStore) {
        super();
        this.customFieldStore = customFieldStore;
    }
    ngOnInit() {
        this.subscription.add(this.value$.subscribe((value) => (this.customFieldValues = value)));
        void this.customFieldStore.preload();
    }
    addEntry() {
        if (this.customFieldValues === undefined)
            this.customFieldValues = [];
        this.customFieldValues.push({});
    }
    removeEntry(index) {
        if (this.customFieldValues === undefined)
            return;
        this.customFieldValues.splice(index, 1);
        this.updateValue();
    }
    updateValue() {
        if (!this.customFieldValues || this.customFieldValues.length === 0)
            void this.setValue(undefined);
        else
            void this.setValue(this.customFieldValues);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: CustomFieldsInputWidgetComponent, deps: [{ token: i1.CustomFieldStore }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.8", type: CustomFieldsInputWidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"options$ | async as options\">\n  <ng-container *ngIf=\"path$ | async as path\">\n    <smallstack-store-container [store]=\"customFieldStore\">\n      <div class=\"outline-border flex flex-col gap-2\">\n        <div *ngIf=\"options?.showLabel !== false\" class=\"title\">Benutzerdefinierte Felder</div>\n        <div style=\"padding-top: 2px\" class=\"flex flex-col gap-2\">\n          <ng-container *ngFor=\"let customFieldValue of customFieldValues; let index = index\">\n            <div class=\"flex flex-row gap-1 justify-start w-full\">\n              <div class=\"form-control\">\n                <label class=\"label smallstack-label\">\n                  <span class=\"label-text\">Feld ausw\u00E4hlen</span>\n                </label>\n                <select\n                  class=\"select select-bordered\"\n                  [(ngModel)]=\"customFieldValue.customFieldId\"\n                  (ngModelChange)=\"updateValue()\"\n                  attr.data-test=\"schema-form-widget-custom-fields-{{ path }}\"\n                >\n                  <option\n                    *ngFor=\"let customField of customFieldStore.value$ | async\"\n                    [value]=\"customField.id\"\n                    attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-option-{{\n                      customField.key | urlconform\n                    }}\"\n                  >\n                    <smallstack-i18n [data]=\"customField.title\"></smallstack-i18n\n                    ><span *ngIf=\"customField.predefinedValue\"> ({{ customField.predefinedValue.value }})</span>\n                  </option>\n                </select>\n              </div>\n              <smallstack-store-model\n                *ngIf=\"customFieldValue.customFieldId\"\n                [store]=\"customFieldStore\"\n                [modelId]=\"customFieldValue.customFieldId\"\n              >\n                <ng-template let-customField>\n                  <ng-container *ngIf=\"customField.predefinedValue; else customValueEditor\">\n                    <div class=\"form-control w-full max-w-xs\">\n                      <label class=\"label smallstack-label\">\n                        <span class=\"label-text\">Wert</span>\n                      </label>\n                      <input\n                        type=\"text\"\n                        readonly\n                        disabled\n                        class=\"input input-bordered w-full max-w-xs disabled\"\n                        [ngModel]=\"customField.predefinedValue.value\"\n                      />\n                    </div>\n                    <div class=\"form-control w-full max-w-xs\">\n                      <label class=\"label smallstack-label\">\n                        <span class=\"label-text whitespace-nowrap\">Beschreibung des Wertes</span>\n                      </label>\n                      <input\n                        type=\"text\"\n                        readonly\n                        disabled\n                        class=\"input input-bordered w-full max-w-xs disabled\"\n                        [value]=\"customField.predefinedValue.title | translate\"\n                      />\n                    </div>\n                  </ng-container>\n\n                  <ng-template #customValueEditor>\n                    <ng-container [ngSwitch]=\"customField.type\">\n                      <ng-container *ngSwitchCase=\"'boolean'\">\n                        <mat-checkbox\n                          style=\"padding: 3px\"\n                          [checked]=\"customFieldValue.value === 'true'\"\n                          (change)=\"customFieldValue.value = '' + $event.checked; updateValue()\"\n                          attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          ><smallstack-i18n [data]=\"customField.title\"></smallstack-i18n\n                        ></mat-checkbox>\n                      </ng-container>\n                      <ng-container *ngSwitchCase=\"'date'\">\n                        <mat-form-field>\n                          <mat-label> Wert </mat-label>\n                          <input\n                            matInput\n                            [(ngModel)]=\"customFieldValue.value\"\n                            type=\"date\"\n                            (ngModelChange)=\"updateValue()\"\n                            attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          />\n                        </mat-form-field>\n                      </ng-container>\n                      <ng-container *ngSwitchCase=\"'datestring'\">\n                        <smallstack-datestring-editor\n                          [timestamp]=\"customFieldValue.value\"\n                          (timestampChange)=\"customFieldValue.value = '' + $event\"\n                          attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                        ></smallstack-datestring-editor>\n                      </ng-container>\n                      <ng-container *ngSwitchDefault>\n                        <div class=\"form-control w-full max-w-xs\">\n                          <label class=\"label smallstack-label\">\n                            <span class=\"label-text\">Wert</span>\n                          </label>\n                          <input\n                            type=\"text\"\n                            class=\"input input-bordered w-full max-w-xs\"\n                            [(ngModel)]=\"customFieldValue.value\"\n                            (ngModelChange)=\"updateValue()\"\n                            attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          />\n                        </div>\n                      </ng-container>\n                    </ng-container>\n\n                    <smallstack-widget-renderer\n                      *ngIf=\"customFieldValue.customFieldId\"\n                      [widget]=\"{\n                        name: 'I18nInput',\n                        data: { path: path + '.' + index + '.title', options: { showLabel: true } }\n                      }\"\n                    ></smallstack-widget-renderer>\n                  </ng-template>\n                </ng-template>\n              </smallstack-store-model>\n              <button class=\"btn btn-secondary my-6\" (click)=\"removeEntry(index)\">\n                <smallstack-icon\n                  name=\"trash\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.secondary.textColor\"\n                ></smallstack-icon>\n              </button>\n            </div>\n          </ng-container>\n        </div>\n        <button class=\"btn btn-block btn-sm btn-secondary\" (click)=\"addEntry()\">\n          <smallstack-icon\n            name=\"plus-math\"\n            size=\"24\"\n            theme=\"fluency-systems-regular\"\n            themeColor=\"daisyTheme.secondary.textColor\"\n          ></smallstack-icon>\n        </button>\n      </div>\n    </smallstack-store-container>\n  </ng-container>\n</ng-container>\n", dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i2.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1$1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1$1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i4.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatLabel, selector: "mat-label" }, { kind: "component", type: StoreContainerComponent, selector: "smallstack-store-container", inputs: ["store", "loadingText", "showErrorIcon", "showErrorText"] }, { kind: "pipe", type: UrlConformPipe, name: "urlconform" }, { kind: "pipe", type: TranslatePipe, name: "translate" }, { kind: "component", type: StoreModelComponent, selector: "smallstack-store-model", inputs: ["store", "modelId", "notFound"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: DatestringEditorComponent, selector: "smallstack-datestring-editor", inputs: ["timestamp", "layout", "defaultsToNow", "onlyDateInFuture", "onlyDateInPast", "label"], outputs: ["timestampChange"] }, { kind: "component", type: WidgetRendererComponent, selector: "smallstack-widget-renderer", inputs: ["widget", "additionalProviders", "context", "class"], outputs: ["widgetChange"] }, { kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i5.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.8", ngImport: i0, type: CustomFieldsInputWidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        MatFormFieldModule,
                        StoreContainerComponent,
                        UrlConformPipe,
                        TranslatePipe,
                        StoreModelComponent,
                        IconComponent,
                        I18nComponent,
                        DatestringEditorComponent,
                        WidgetRendererComponent,
                        MatCheckboxModule
                    ], template: "<ng-container *ngIf=\"options$ | async as options\">\n  <ng-container *ngIf=\"path$ | async as path\">\n    <smallstack-store-container [store]=\"customFieldStore\">\n      <div class=\"outline-border flex flex-col gap-2\">\n        <div *ngIf=\"options?.showLabel !== false\" class=\"title\">Benutzerdefinierte Felder</div>\n        <div style=\"padding-top: 2px\" class=\"flex flex-col gap-2\">\n          <ng-container *ngFor=\"let customFieldValue of customFieldValues; let index = index\">\n            <div class=\"flex flex-row gap-1 justify-start w-full\">\n              <div class=\"form-control\">\n                <label class=\"label smallstack-label\">\n                  <span class=\"label-text\">Feld ausw\u00E4hlen</span>\n                </label>\n                <select\n                  class=\"select select-bordered\"\n                  [(ngModel)]=\"customFieldValue.customFieldId\"\n                  (ngModelChange)=\"updateValue()\"\n                  attr.data-test=\"schema-form-widget-custom-fields-{{ path }}\"\n                >\n                  <option\n                    *ngFor=\"let customField of customFieldStore.value$ | async\"\n                    [value]=\"customField.id\"\n                    attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-option-{{\n                      customField.key | urlconform\n                    }}\"\n                  >\n                    <smallstack-i18n [data]=\"customField.title\"></smallstack-i18n\n                    ><span *ngIf=\"customField.predefinedValue\"> ({{ customField.predefinedValue.value }})</span>\n                  </option>\n                </select>\n              </div>\n              <smallstack-store-model\n                *ngIf=\"customFieldValue.customFieldId\"\n                [store]=\"customFieldStore\"\n                [modelId]=\"customFieldValue.customFieldId\"\n              >\n                <ng-template let-customField>\n                  <ng-container *ngIf=\"customField.predefinedValue; else customValueEditor\">\n                    <div class=\"form-control w-full max-w-xs\">\n                      <label class=\"label smallstack-label\">\n                        <span class=\"label-text\">Wert</span>\n                      </label>\n                      <input\n                        type=\"text\"\n                        readonly\n                        disabled\n                        class=\"input input-bordered w-full max-w-xs disabled\"\n                        [ngModel]=\"customField.predefinedValue.value\"\n                      />\n                    </div>\n                    <div class=\"form-control w-full max-w-xs\">\n                      <label class=\"label smallstack-label\">\n                        <span class=\"label-text whitespace-nowrap\">Beschreibung des Wertes</span>\n                      </label>\n                      <input\n                        type=\"text\"\n                        readonly\n                        disabled\n                        class=\"input input-bordered w-full max-w-xs disabled\"\n                        [value]=\"customField.predefinedValue.title | translate\"\n                      />\n                    </div>\n                  </ng-container>\n\n                  <ng-template #customValueEditor>\n                    <ng-container [ngSwitch]=\"customField.type\">\n                      <ng-container *ngSwitchCase=\"'boolean'\">\n                        <mat-checkbox\n                          style=\"padding: 3px\"\n                          [checked]=\"customFieldValue.value === 'true'\"\n                          (change)=\"customFieldValue.value = '' + $event.checked; updateValue()\"\n                          attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          ><smallstack-i18n [data]=\"customField.title\"></smallstack-i18n\n                        ></mat-checkbox>\n                      </ng-container>\n                      <ng-container *ngSwitchCase=\"'date'\">\n                        <mat-form-field>\n                          <mat-label> Wert </mat-label>\n                          <input\n                            matInput\n                            [(ngModel)]=\"customFieldValue.value\"\n                            type=\"date\"\n                            (ngModelChange)=\"updateValue()\"\n                            attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          />\n                        </mat-form-field>\n                      </ng-container>\n                      <ng-container *ngSwitchCase=\"'datestring'\">\n                        <smallstack-datestring-editor\n                          [timestamp]=\"customFieldValue.value\"\n                          (timestampChange)=\"customFieldValue.value = '' + $event\"\n                          attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                        ></smallstack-datestring-editor>\n                      </ng-container>\n                      <ng-container *ngSwitchDefault>\n                        <div class=\"form-control w-full max-w-xs\">\n                          <label class=\"label smallstack-label\">\n                            <span class=\"label-text\">Wert</span>\n                          </label>\n                          <input\n                            type=\"text\"\n                            class=\"input input-bordered w-full max-w-xs\"\n                            [(ngModel)]=\"customFieldValue.value\"\n                            (ngModelChange)=\"updateValue()\"\n                            attr.data-test=\"schema-form-widget-custom-fields-{{ path }}-value\"\n                          />\n                        </div>\n                      </ng-container>\n                    </ng-container>\n\n                    <smallstack-widget-renderer\n                      *ngIf=\"customFieldValue.customFieldId\"\n                      [widget]=\"{\n                        name: 'I18nInput',\n                        data: { path: path + '.' + index + '.title', options: { showLabel: true } }\n                      }\"\n                    ></smallstack-widget-renderer>\n                  </ng-template>\n                </ng-template>\n              </smallstack-store-model>\n              <button class=\"btn btn-secondary my-6\" (click)=\"removeEntry(index)\">\n                <smallstack-icon\n                  name=\"trash\"\n                  theme=\"fluency-systems-regular\"\n                  themeColor=\"daisyTheme.secondary.textColor\"\n                ></smallstack-icon>\n              </button>\n            </div>\n          </ng-container>\n        </div>\n        <button class=\"btn btn-block btn-sm btn-secondary\" (click)=\"addEntry()\">\n          <smallstack-icon\n            name=\"plus-math\"\n            size=\"24\"\n            theme=\"fluency-systems-regular\"\n            themeColor=\"daisyTheme.secondary.textColor\"\n          ></smallstack-icon>\n        </button>\n      </div>\n    </smallstack-store-container>\n  </ng-container>\n</ng-container>\n" }]
        }], ctorParameters: function () { return [{ type: i1.CustomFieldStore }]; } });

export { CustomFieldsInputWidgetComponent };
//# sourceMappingURL=smallstack-form-widgets-custom-fields-input-widget.component-b8d5bcce.mjs.map
